function [ Pop,obj_var,VI_data ] = NSGA2( ObjectionFunc, Max_NFE, M )  
%NSGA2 ˴ʾйش˺ժҪ

    global  nfeval VD PGS emission ploss VI fuelvlvcost Qgen wgencost sgencost cumcost
    
    weibullplot(); % for plotting Weibull PDF
    lognplot(); % for plotting lognormal PDF
    
    D = 11;
    NP =100;
    %%%% Χ Ptg2bus2 Pws1(bus5) Ptg3(bus8) Pws2(bus11) Pss(bus13) V1 V2 V5 V8 V11 V13
    LB = [20  0 10  0  0 0.95 0.95 0.95 0.95 0.95 0.95];
    UB = [80 75 35 60 50 1.1 1.1 1.1 1.1 1.1 1.1];
    
    gn = 4; % gn is the no. of constraints 4Լ
    N = 2; %%% ʾźԼռ2λ

    %30άNPΪ100 
    NFE = 0;
    %% Initialization
    for i=1:NP
         for j=1:D
             Pop(i,j) = LB(j)+rand*(UB(j)-LB(j));
         end
    end
    
    %% Evaluation
     obj_var = [];
     VI_data = [];
     for i=1:NP
         [Pop(i,D+1:D+M),g(i,:),obj_var(i,:),VI_data(i,:)] = ObjectionFunc(Pop(i,1:D));
     end
     
     %%% ֧
     Pop = NonDominatedSort(Pop,D,M,N);
     Pop(1:NP,D+M+1) = 1:NP;
     Pop(1:NP,D+M+N) = 0;
     
     NFE = NFE+NP;
     
     MaxGen = Max_NFE/NP;

    %% Start main loop
    for gen = 1:MaxGen
        
        GG = [];
        cons_max = [];
        OffspringPop = [];
        cons1 = [];
        newg = [];
        tcons1 = [];
        Rt = [];
        
        new_obj_var = [];
        new_VI_data = [];
        var = [];
        data = [];  
        
        pool_size = round(NP/2); %  pool size
        tour_size = 2; % Number of contestants        
        Pop_pool = Tournament_selection(Pop,pool_size,tour_size); % Tournament selection
        [OffspringPop,newg,new_obj_var,new_VI_data] = GeneticOperator(Pop_pool,M,N,D,LB,UB);
        
        
                %%%%%% 
        var = vertcat(obj_var,new_obj_var);
        data = vertcat(VI_data,new_VI_data);
        
        % Superiority of Feasible Solutions
        GG = vertcat(g,newg);
        [sGG,~] = size(GG);
        cons1=(GG>0).*GG;  %%% GG>0 ʾΪ0ԪӦֵΪ1
        cons_max=max([cons_max;cons1],[],1);%[cons_max;cons1]ֱ  %%% max([cons_max;cons1],[],1)ҳΥһ
        nzindex1=find(cons_max~=0);  %%%% Υһв0Ԫڵ
        
        if isempty(nzindex1)  %%%% ֵΪգΥ0
            tcons1=zeros(sGG,1);
        else  %%%%  ֵΪգ  cons1(:,nzindex1)./repmat(cons_max(:,nzindex1),size(AA,1),1),2  
            tcons1=sum(cons1(:,nzindex1)./repmat(cons_max(:,nzindex1),sGG,1),2)./sum(1./cons_max(:,nzindex1));   %%%%%Υȼ
        end
        
        % Combined Population: Rt
        [OffspringPop_NP,~] = size(OffspringPop);
        OffspringPop(1:OffspringPop_NP,D+M+1) = (NP+1):(NP+OffspringPop_NP);
        Rt(1:NP,:) = Pop;
        Rt(NP+1:NP+OffspringPop_NP,:) = OffspringPop;
        
        % Non-dominated sort and crowded distance calculation for Rt
        Rt = NonDominatedSort(Rt,D,M,N);
        
        Rt(:,D+M+N) = tcons1(Rt(:,D+M+1));
        
        % Selection based on non-dominated sort and crowded distance
        Pop = Selection(Rt,NP,M,D,N);
        obj_var(1:NP,:) = var(Pop(:,D+M+1),:);
        VI_data(1:NP,:) = data(Pop(:,D+M+1),:);
        g(1:NP,:) = GG(Pop(:,D+M+1),:);
        %%% Ⱥ
        Pop(:,D+M+1) = 1:NP;
        %g = GG(Pop(:,D+M+N),:);
              
               
    end


